<?php

require_once __DIR__."/../vendor/autoload.php";

use NoccyLabs\VarType\VarType;

$mock_config = [
    "foo" => [ 0, VarType::int(0) ],
    "bar" => [ false, VarType::bool(false) ],
    "baz" => [ "foo", VarType::enum("foo",["foo","bin","baz"]) ],
];
function set_config($key,$value) {
    global $mock_config;
    if (!$mock_config[$key][1]->isValid($value)) {
        echo "Bad value for {$key}\n";
        return;
    }
    $mock_config[$key][0] = $mock_config[$key][1]->cast($value);
}


set_config("foo", 42);
set_config("bar", true);
set_config("bar", 42);
set_config("baz", "bin");
set_config("baz", "barf");

var_dump($mock_config);
