<?php

namespace NoccyLabs\VarType;

class ValueType extends VarType
{

    private $value;

    public static function __callStatic($method, $args)
    {
        $def=(count($args)>0)?$args[0]:null;
        $conf=(count($args)>1)?$args[1]:null;
        if (!array_key_exists($method,self::$TYPES)) {
            throw new \Exception("No such var type: {$method}");
        }
        return new ValueType($method,$def,$conf);
    }
    
    public function __construct($type,$def,$conf)
    {
        parent::__construct($type,$def,$conf);
        $this->value = $def;
    }

    public function setValue($value)
    {
        if (!$this->isValid($value)) {
            return false;
        }
        $this->value = $this->cast($value);
        return true;
    }
    
    public function getValue()
    {
        return $this->value;
    }

}
